=begin
 Copyright 2010, AlexM

 THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
 IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

 Author :          AlexM
 Description:      UI module extensions for ArchTools scripts.
 Date :            2010-06-10
=end

module Object::UI

class Command
	class << self
		unless private_method_defined? :new_ORIG
			alias :new_ORIG :new
			private :new_ORIG
		end
	end#do
end

#---------------------------------------------------------------------------------------------------

COMMANDS = Hash.new {|h,k| h[k] = Array.new} if not defined? COMMANDS

def self.get_New_Commands(num)
	c = COMMANDS[:ALL].length
	cmd = 'cmd_0' + c.to_s
num.times do |i| 
	Kernel.eval(
%|#{cmd.next!} = UI::Command.__send__(:new_ORIG, \"#{cmd}\"){UI::COMMANDS[:ALL].at(#{i+c}).call}
#{cmd}.instance_eval do
def call; @cmd_proc.call if @cmd_proc; end
def unused?; !@used; end
def make_used; @used=true; self; end
def release; @used=nil; end
def name; @name; end
def set!(menuText, statusBarText=true, vld_proc=nil, cmd_proc=nil, &cmd_block)
	self.menu_text = menuText
	self.status_bar_text = statusBarText.is_a?(TrueClass) ? menuText : statusBarText
	self.set_validation_proc &(vld_proc.is_a?(Proc) ? vld_proc : proc{MF_ENABLED})
	@cmd_proc = block_given? ? cmd_block : cmd_proc
	list = UI::COMMANDS[menuText]
	list << self unless list.include?(self)
	UI::COMMANDS[:UNU].delete(self)
	@name = menuText
	@used = true
	return self
end#def
end#i_eval
UI::COMMANDS[:ALL] << #{cmd}
UI::COMMANDS[:UNU] << #{cmd}
|)#eval
end#do
	return COMMANDS[:ALL][c..-1]
end#def

def self.get_Unused_Command(name)
	COMMANDS[name].each{|c| return c if c.unused? }
	COMMANDS[:UNU].each{|c| return c if c.unused? }
	UI.get_New_Commands(1).at(0)
end#def

def self.get_Unused_Commands(*names)
	f = names.first
	names = f if f.is_a?(Array) && names.length == 1
	coms = []
	for name in names
		coms << UI.get_Unused_Command(name).make_used
	end
	return coms
end#def

def self.release_Commands(commands=nil, release_names=false)
	commands=COMMANDS[:ALL] if not commands
	for com in commands
		com.release
		if release_names and COMMANDS[com.name].delete(com)
			COMMANDS[:UNU] << com
		end
	end
	COMMANDS.delete(nil) if release_names
end#def

def self.count_Unused_Commands
	COMMANDS[:ALL].select{|c| c.unused? }.length
end#def

end#module